#!/bin/sh
#
# script file to start udhcpd daemon (udhcp server)
#

if [ $# -lt 2 ]; then echo "Usage: $0 interface {gw | ap} ";  exit 1 ; fi

GETMIB="flash get"
CONF_FILE=/var/udhcpd.conf
LEASE_FILE=/var/lib/misc/udhcpd.leases

# See if DHCP server is on
eval `$GETMIB DHCP`
if [ "$DHCP" != '2' ]; then
	exit 0
fi

echo "interface $1" > $CONF_FILE

eval `$GETMIB DHCP_CLIENT_START`
echo "start $DHCP_CLIENT_START" >> $CONF_FILE

eval `$GETMIB DHCP_CLIENT_END`
echo "end $DHCP_CLIENT_END" >> $CONF_FILE

eval `$GETMIB SUBNET_MASK`
echo "opt subnet $SUBNET_MASK" >> $CONF_FILE

if [ $2 = "ap" ]; then
	eval `$GETMIB DEFAULT_GATEWAY`
	echo "opt router $DEFAULT_GATEWAY"  >> $CONF_FILE

	eval `$GETMIB DNS1`
	if [ "$DNS1" != "0.0.0.0" ]; then
		echo "opt dns $DNS1" >> $CONF_FILE
	fi
	eval `$GETMIB DNS2`
	if [ "$DNS2" != "0.0.0.0" ]; then
		echo "opt dns $DNS2" >> $CONF_FILE
	fi
	eval `$GETMIB DNS3`
	if [ "$DNS3" != "0.0.0.0" ]; then
		echo "opt dns $DNS3" >> $CONF_FILE
	fi
	# set default
	if [ "`cat $CONF_FILE | grep dns`" = "" ]; then
		echo "opt dns $DEFAULT_GATEWAY"  >> $CONF_FILE
	fi

else
	eval `$GETMIB IP_ADDR`
	echo "opt router $IP_ADDR"  >> $CONF_FILE

	eval `$GETMIB DNS_MODE`
	if [ "$DNS_MODE" = '0' ]; then
		echo "opt dns $IP_ADDR" >> $CONF_FILE
	else
		eval `$GETMIB DNS1`
		if [ "$DNS1" != "0.0.0.0" ]; then
			echo "opt dns $DNS1" >> $CONF_FILE
		fi
		eval `$GETMIB DNS2`
		if [ "$DNS2" != "0.0.0.0" ]; then
			echo "opt dns $DNS2" >> $CONF_FILE
		fi
		eval `$GETMIB DNS3`
		if [ "$DNS3" != "0.0.0.0" ]; then
			echo "opt dns $DNS3" >> $CONF_FILE
		fi
	fi
	# set default
	if [ "`cat $CONF_FILE | grep dns`" = "" ]; then
		echo "opt dns $IP_ADDR"  >> $CONF_FILE
	fi
fi

# added by Eason, 2006/4/3
eval `$GETMIB STATICLEASE_TBL_NUM`
if [ $STATICLEASE_TBL_NUM -gt 0 ]; then
  num=1
  while [ $num -le $STATICLEASE_TBL_NUM ];
  do
    STATICLEASE_TBL=`$GETMIB STATICLEASE_TBL | grep STATICLEASE_TBL$num`
    tmp_addr=`echo $STATICLEASE_TBL | cut -f2 -d=`
    macaddr=`echo $tmp_addr | cut -f1 -d,`
    ipaddr=`echo $tmp_addr | cut -f2 -d,`
    echo "static_lease $macaddr $ipaddr" >> $CONF_FILE
    num=`expr $num + 1`
  done
fi

if [ -f "$LEASE_FILE" ]; then
	rm -f $LEASE_FILE
fi

echo "" > $LEASE_FILE

eval `$GETMIB IP_ADDR`
fixedip.sh $1 $IP_ADDR $SUBNET_MASK 0.0.0.0

udhcpd $CONF_FILE

#marked for new ethernet driver by Richard H., 2006/2/14
#added for updating DHCP Client PC information by Richard H., 2005/11/28
#eval `flash get SHIPPING_MODEL`
#if [ "$SHIPPING_MODEL" = '1' ]; then
#	if [ "$MODEL_TYPE" = 'ZYXELTC' ] || [ "$MODEL_TYPE" = 'ZYXEL' ]; then
#		PIDFILE=/var/UPDATE_DHCP_CLIENT
#		if [ -f $PIDFILE ]; then
#			PID=`cat $PIDFILE`
#			if [ $PID = 1 ]; then
#    	        echo 'Start to update DHCP client PC information'
#    	        iwpriv wlan0 write_mem dw,bd30005c,1,80003900
#    	        iwpriv wlan0 write_mem dw,bd30005c,1,84003900
#    	        iwpriv wlan0 write_mem dw,bd30005c,1,88003900
#    	        iwpriv wlan0 write_mem dw,bd30005c,1,8c003900
#    	        sleep 10
#    	        iwpriv wlan0 write_mem dw,bd30005c,1,80003100
#    	        iwpriv wlan0 write_mem dw,bd30005c,1,84003100
#    	        iwpriv wlan0 write_mem dw,bd30005c,1,88003100
#    	        iwpriv wlan0 write_mem dw,bd30005c,1,8c003100
#    	    fi
#    	    rm -f $PIDFILE
#    	fi
#    fi
#fi