#!/bin/sh

ip=0
port1=0
port2=0
protocol=0
ZERO=0
WAN=eth1
BRIDGE=br0
REMOTEMGTPORT=8080  #maxchang: remote management port

eval `flash get MODEL_TYPE`
eval `flash get WAN_DHCP`
eval `flash get IPFILTER_TBL_NUM`
eval `flash get PORTFILTER_TBL_NUM`
eval `flash get MACFILTER_TBL_NUM`
eval `flash get PORTFW_TBL_NUM`
eval `flash get DMZ_HOST`

eval `flash get IPFILTER_ENABLED`
eval `flash get PORTFILTER_ENABLED`
eval `flash get MACFILTER_ENABLED`
eval `flash get PORTFW_ENABLED`
eval `flash get DMZ_ENABLED`
eval `flash get OP_MODE`
eval `flash get WEB_WAN_ACCESS_ENABLED`
eval `flash get WEB_WAN_ACCESS_PORT`    #maxchang: remote management port
eval `flash get IP_ADDR`                #maxchang: ip of lan interface
eval `flash get REMOTE_TELNET`

eval `flash get SPAP_ENABLE1`
eval `flash get SPAP_ENABLE2`
eval `flash get SPAP_ENABLE3`
eval `flash get SPAP_ENABLE4`
eval `flash get SPAP_ENABLE5`
eval `flash get SPAP_ENABLE6`
eval `flash get SPAP_ENABLE7`
eval `flash get SPAP_ENABLE8`

#maxchang, check if remote management port is valid
if [ $WEB_WAN_ACCESS_PORT -ge 0 ] && [ $WEB_WAN_ACCESS_PORT -le 65535 ];then
    REMOTEMGTPORT=$WEB_WAN_ACCESS_PORT
fi
LAN_IP=$IP_ADDR

# if wireless ISP mode , set WAN to wlan0
eval `flash get  WISP_WAN_ID`
if [ "$OP_MODE" = '2' ];then
	WAN=wlan$WISP_WAN_ID
fi

if [ $WAN_DHCP = 3 ] || [ $WAN_DHCP = 4 ] || [ $WAN_DHCP = 5 ]; then
	#modified by Eason, 2006/5/15
	if [ $# -eq 1 ] && [ $1 = 'preppp' ]; then
  	WAN=eth1
  else
  	WAN=ppp0
  fi
fi



EXT_IP0=`ifconfig $WAN | grep -i "addr:"`
EXT_IP1=`echo $EXT_IP0 | cut -f2 -d:`
EXT_IP=`echo $EXT_IP1 | cut -f1 -d " "`
INT_IP0=`ifconfig $BRIDGE | grep -i "addr:"`
INT_IP1=`echo $INT_IP0 | cut -f2 -d:`
INT_IP=`echo $INT_IP1 | cut -f1 -d " "`

iptables -F
iptables -t nat -F PREROUTING
iptables -t nat -F POSTROUTING
iptables -F INPUT
iptables -F OUTPUT
iptables -F FORWARD
iptables -P OUTPUT ACCEPT

if [ $OP_MODE != 1 ] ; then
	iptables -P INPUT DROP
else
	iptables -P INPUT ACCEPT #default accept
fi

if [ $OP_MODE != 3 ] ; then
	iptables -P FORWARD DROP
else
	iptables -P FORWARD ACCEPT #default accept
fi


echo 1 > /proc/sys/net/ipv4/ip_forward

#if opmode is bridge , exit don't set firewall
#eval `flash get RIP_ENABLED`
#if [ "$OP_MODE" = '1' ] || [ "$RIP_ENABLED" = '1' ] ; then
if [ "$OP_MODE" = '1' ];then
	exit
fi

# modified by Eason, in fixed ip mode, using SNAT is more efficiently than MASQUERADE
if [ $WAN_DHCP -eq '0' ]; then
    iptables -t nat -A POSTROUTING -o $WAN -j SNAT --to $EXT_IP
else
    iptables -t nat -A POSTROUTING -o $WAN -j MASQUERADE

    if [ $MODEL_TYPE = "ZYXELRUS" ]; then
        #if [ $WAN_DHCP = 4 ] || [ $WAN_DHCP = 5 ]; then
        if [ $WAN_DHCP = 3 ] || [ $WAN_DHCP = 4 ] || [ $WAN_DHCP = 5 ]; then
            if [ "$OP_MODE" = '0' ];then
                EXT_IF=eth1
            elif [ "$OP_MODE" = '2' ];then
                EXT_IF=wlan$WISP_WAN_ID
            fi

            EXT_IP0_ADDR=`ifconfig $EXT_IF | grep -i "addr:"`
            EXT_IP1_ADDR=`echo $EXT_IP0_ADDR | cut -f2 -d:`
            EXT_IP_ADDR=`echo $EXT_IP1_ADDR | cut -f1 -d " "`

            iptables -t nat -A POSTROUTING -o $EXT_IF -j SNAT --to $EXT_IP_ADDR
        fi
    fi
fi

eval `flash get VPN_PASSTHRU_PPTP_ENABLED`
if [ $VPN_PASSTHRU_PPTP_ENABLED = 0 ];then
       iptables -A FORWARD -p TCP --dport 1723 -j DROP
fi
eval `flash get VPN_PASSTHRU_L2TP_ENABLED`
if [ $VPN_PASSTHRU_L2TP_ENABLED = 0 ];then
       iptables -A FORWARD -p UDP --dport 1701 -j DROP
fi
eval `flash get VPN_PASSTHRU_IPSEC_ENABLED`
if [ $VPN_PASSTHRU_IPSEC_ENABLED = 0 ];then
       iptables -A FORWARD -p UDP --dport 500 -j DROP
fi

eval `flash get URLFILTER_ENABLED`
eval `flash get URLFILTER_TBL_NUM`
if [ $URLFILTER_TBL_NUM -gt 0 ] && [ $URLFILTER_ENABLED -gt 0 ];then
  url="$URLFILTER_TBL_NUM "
  num=1
  while [ $num -le $URLFILTER_TBL_NUM ];
  do
    str=`flash get URLFILTER_TBL | grep URLFILTER_TBL$num`
    str=`echo $str | cut -f2 -d=`
    url="$url $str"
    num=`expr $num + 1`
  done
  echo "$url "> /proc/url_filter
else
  echo "0 "> /proc/url_filter

fi

if [ $IPFILTER_TBL_NUM -gt 0 ] && [ $IPFILTER_ENABLED -gt 0 ];
then
  num=1
  while [ $num -le $IPFILTER_TBL_NUM ];
  do
    IPFILTER_TBL=`flash get IPFILTER_TBL | grep IPFILTER_TBL$num`
    port_ip=`echo $IPFILTER_TBL | cut -f2 -d=`
    ip=`echo $port_ip | cut -f1 -d,`
    protocol=`echo $port_ip | cut -f2 -d,`
    if [ $protocol = 1 ]; then
      iptables -A FORWARD -p TCP -s $ip -j DROP
    fi
    if [ $protocol = 2 ]; then
      iptables -A FORWARD -p UDP -s $ip -j DROP
    fi
    if [ $protocol = 3 ]; then
      iptables -A FORWARD -p TCP -s $ip -j DROP
      iptables -A FORWARD -p UDP -s $ip -j DROP
    fi
    num=`expr $num + 1`
  done
fi

if [ $MACFILTER_TBL_NUM -gt 0 ] && [ $MACFILTER_ENABLED -gt 0 ];
then
  num=1
  while [ $num -le $MACFILTER_TBL_NUM ];
  do
    MACFILTER_TBL=`flash get MACFILTER_TBL | grep MACFILTER_TBL$num`
    tmp_addr=`echo $MACFILTER_TBL | cut -f2 -d=`
    addr=`echo $tmp_addr | cut -f1 -d,`
    iptables -A FORWARD -m mac --mac-source $addr -j DROP
    num=`expr $num + 1`
  done
fi

# default enable nat speedup
if [ -f /proc/fast_nat ];then
	echo "1" > /proc/fast_nat
	echo "1" > /proc/br_nat_speedup
fi

if [ $PORTFILTER_TBL_NUM -gt 0 ] && [ $PORTFILTER_ENABLED -gt 0 ];
then
  num=1
  #if enable port filter , then disable nat speedup for work around
  if [ -f /proc/fast_nat ];then
	echo "0" > /proc/fast_nat
	echo "0" > /proc/br_nat_speedup
  fi

  while [ $num -le $PORTFILTER_TBL_NUM ];
  do
    PORTFILTER_TBL=`flash get PORTFILTER_TBL | grep PORTFILTER_TBL$num`
    port_ip=`echo $PORTFILTER_TBL | cut -f2 -d=`
    port1=`echo $port_ip | cut -f1 -d,`
    tmp_port=`echo $port_ip | cut -f2 -d,`
    port2=`echo $tmp_port | cut -f2 -d ' '`
    protocol=`echo $port_ip | cut -f3 -d,`
    num=`expr $num + 1`

    if [ $protocol = 1 ]; then
       iptables -A FORWARD -p TCP --sport $port1:$port2 -j DROP
    fi
    if [ $protocol = 2 ]; then
       iptables -A FORWARD -p UDP --sport $port1:$port2 -j DROP
    fi
    if [ $protocol = 3 ]; then
       iptables -A FORWARD -p TCP --sport $port1:$port2 -j DROP
       iptables -A FORWARD -p UDP --sport $port1:$port2 -j DROP
    fi
  done
fi

## add for ALG by Richard H.,2005/4/1 18:08
#eval `flash get ALG_ENABLE1`
#eval `flash get ALG_ENABLE2`
#eval `flash get ALG_ENABLE3`
#eval `flash get ALG_ENABLE4`
#eval `flash get ALG_ENABLE5`
#eval `flash get ALG_ENABLE6`
#eval `flash get ALG_ENABLE7`
#eval `flash get ALG_ENABLE8`
#
##AOE
#if [ $ALG_ENABLE1 = 0 ]; then
#	iptables -A FORWARD -p TCP --sport 2300:2400 -j DROP
#    iptables -A FORWARD -p UDP --sport 2300:2400 -j DROP
#    iptables -A FORWARD -p TCP --sport 47624 -j DROP
#fi
##AOL
#if [ $ALG_ENABLE2 = 0 ]; then
#	iptables -A FORWARD -p TCP --sport 5190 -j DROP
#fi
##Battle.net
#if [ $ALG_ENABLE3 = 0 ]; then
#	iptables -A FORWARD -p TCP --sport 6112 -j DROP
#    iptables -A FORWARD -p UDP --sport 6112 -j DROP
#    #iptables -t nat -A PREROUTING -p tcp --dport 6112 -i $BRIDGE -j autofw --related-proto udp --related-dport 6112-6119 --related-to 6112-6119
#fi
##H323
#if [ $ALG_ENABLE4 = 0 ]; then
#	iptables -A FORWARD -p TCP --sport 1503 -j DROP
#	iptables -A FORWARD -p TCP --sport 1720 -j DROP
#fi
##ICQ
#if [ $ALG_ENABLE5 = 0 ]; then
#	iptables -A FORWARD -p TCP --sport 5190 -j DROP
#fi
##IRC
#if [ $ALG_ENABLE6 = 0 ]; then
#	iptables -A FORWARD -p TCP --sport 6660:6669 -j DROP
#    iptables -A FORWARD -p UDP --sport 6660:6669 -j DROP
#fi
##MSN
#if [ $ALG_ENABLE7 = 0 ]; then
#	iptables -A FORWARD -p TCP --sport 1863 -j DROP
#	iptables -A FORWARD -p TCP --sport 6891:6901 -j DROP
#    iptables -A FORWARD -p UDP --sport 1863 -j DROP
#    iptables -A FORWARD -p UDP --sport 5190 -j DROP
#    iptables -A FORWARD -p UDP --sport 6901 -j DROP
#fi
##Yahoo
#if [ $ALG_ENABLE8 = 0 ]; then
#	iptables -A FORWARD -p TCP --sport 5000:5001 -j DROP
#    iptables -A FORWARD -p UDP --sport 5055 -j DROP
#fi

# maxchang: use autofw module to implement special application function
if [ $SPAP_ENABLE1 -gt 0 ];
then
	eval `flash get SPAP_INTYPE1`
	eval `flash get SPAP_INSTART1`
	eval `flash get SPAP_INEND1`
	eval `flash get SPAP_TRTYPE1`
	eval `flash get SPAP_TRSTART1`
	eval `flash get SPAP_TREND1`

    case $SPAP_INTYPE1 in
        0)
            INCOMING_PROTOCOL=TCP
            ;;
        1)
            INCOMING_PROTOCOL=UDP
            ;;
    esac

    case $SPAP_TRTYPE1 in
        0)
            TRIGGER_PROTOCOL=TCP
            ;;
        1)
            TRIGGER_PROTOCOL=UDP
            ;;
    esac

    if [ $SPAP_INTYPE1 != 2 ] && [ $SPAP_TRTYPE1 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
    elif [ $SPAP_INTYPE1 = 2 ] && [ $SPAP_TRTYPE1 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
    elif [ $SPAP_INTYPE1 != 2 ] && [ $SPAP_TRTYPE1 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
    elif [ $SPAP_INTYPE1 = 2 ] && [ $SPAP_TRTYPE1 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART1:$SPAP_TREND1 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART1-$SPAP_INEND1 --related-to $SPAP_INSTART1-$SPAP_INEND1
    fi
fi

if [ $SPAP_ENABLE2 -gt 0 ];
then
	eval `flash get SPAP_INTYPE2`
	eval `flash get SPAP_INSTART2`
	eval `flash get SPAP_INEND2`
	eval `flash get SPAP_TRTYPE2`
	eval `flash get SPAP_TRSTART2`
	eval `flash get SPAP_TREND2`

    case $SPAP_INTYPE2 in
        0)
            INCOMING_PROTOCOL=TCP
            ;;
        1)
            INCOMING_PROTOCOL=UDP
            ;;
    esac

    case $SPAP_TRTYPE2 in
        0)
            TRIGGER_PROTOCOL=TCP
            ;;
        1)
            TRIGGER_PROTOCOL=UDP
            ;;
    esac

    if [ $SPAP_INTYPE2 != 2 ] && [ $SPAP_TRTYPE2 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
    elif [ $SPAP_INTYPE2 = 2 ] && [ $SPAP_TRTYPE2 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
    elif [ $SPAP_INTYPE2 != 2 ] && [ $SPAP_TRTYPE2 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
    elif [ $SPAP_INTYPE2 = 2 ] && [ $SPAP_TRTYPE2 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART2:$SPAP_TREND2 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART2-$SPAP_INEND2 --related-to $SPAP_INSTART2-$SPAP_INEND2
    fi
fi

if [ $SPAP_ENABLE3 -gt 0 ];
then
	eval `flash get SPAP_INTYPE3`
	eval `flash get SPAP_INSTART3`
	eval `flash get SPAP_INEND3`
	eval `flash get SPAP_TRTYPE3`
	eval `flash get SPAP_TRSTART3`
	eval `flash get SPAP_TREND3`

    case $SPAP_INTYPE3 in
        0)
            INCOMING_PROTOCOL=TCP
            ;;
        1)
            INCOMING_PROTOCOL=UDP
            ;;
    esac

    case $SPAP_TRTYPE3 in
        0)
            TRIGGER_PROTOCOL=TCP
            ;;
        1)
            TRIGGER_PROTOCOL=UDP
            ;;
    esac

    if [ $SPAP_INTYPE3 != 2 ] && [ $SPAP_TRTYPE3 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
    elif [ $SPAP_INTYPE3 = 2 ] && [ $SPAP_TRTYPE3 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
    elif [ $SPAP_INTYPE3 != 2 ] && [ $SPAP_TRTYPE3 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
    elif [ $SPAP_INTYPE3 = 2 ] && [ $SPAP_TRTYPE3 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART3:$SPAP_TREND3 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART3-$SPAP_INEND3 --related-to $SPAP_INSTART3-$SPAP_INEND3
    fi
fi

if [ $SPAP_ENABLE4 -gt 0 ]; then
	eval `flash get SPAP_INTYPE4`
	eval `flash get SPAP_INSTART4`
	eval `flash get SPAP_INEND4`
	eval `flash get SPAP_TRTYPE4`
	eval `flash get SPAP_TRSTART4`
	eval `flash get SPAP_TREND4`

    case $SPAP_INTYPE4 in
        0)
            INCOMING_PROTOCOL=TCP
            ;;
        1)
            INCOMING_PROTOCOL=UDP
            ;;
    esac

    case $SPAP_TRTYPE4 in
        0)
            TRIGGER_PROTOCOL=TCP
            ;;
        1)
            TRIGGER_PROTOCOL=UDP
            ;;
    esac

    if [ $SPAP_INTYPE4 != 2 ] && [ $SPAP_TRTYPE4 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
    elif [ $SPAP_INTYPE4 = 2 ] && [ $SPAP_TRTYPE4 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
    elif [ $SPAP_INTYPE4 != 2 ] && [ $SPAP_TRTYPE4 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
    elif [ $SPAP_INTYPE4 = 2 ] && [ $SPAP_TRTYPE4 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART4:$SPAP_TREND4 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART4-$SPAP_INEND4 --related-to $SPAP_INSTART4-$SPAP_INEND4
    fi
fi

if [ $SPAP_ENABLE5 -gt 0 ];
then
	eval `flash get SPAP_INTYPE5`
	eval `flash get SPAP_INSTART5`
	eval `flash get SPAP_INEND5`
	eval `flash get SPAP_TRTYPE5`
	eval `flash get SPAP_TRSTART5`
	eval `flash get SPAP_TREND5`

    case $SPAP_INTYPE5 in
        0)
            INCOMING_PROTOCOL=TCP
            ;;
        1)
            INCOMING_PROTOCOL=UDP
            ;;
    esac

    case $SPAP_TRTYPE5 in
        0)
            TRIGGER_PROTOCOL=TCP
            ;;
        1)
            TRIGGER_PROTOCOL=UDP
            ;;
    esac

    if [ $SPAP_INTYPE5 != 2 ] && [ $SPAP_TRTYPE5 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
    elif [ $SPAP_INTYPE5 = 2 ] && [ $SPAP_TRTYPE5 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
    elif [ $SPAP_INTYPE5 != 2 ] && [ $SPAP_TRTYPE5 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
    elif [ $SPAP_INTYPE5 = 2 ] && [ $SPAP_TRTYPE5 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART5:$SPAP_TREND5 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART5-$SPAP_INEND5 --related-to $SPAP_INSTART5-$SPAP_INEND5
    fi
fi

if [ $SPAP_ENABLE6 -gt 0 ];
then
	eval `flash get SPAP_INTYPE6`
	eval `flash get SPAP_INSTART6`
	eval `flash get SPAP_INEND6`
	eval `flash get SPAP_TRTYPE6`
	eval `flash get SPAP_TRSTART6`
	eval `flash get SPAP_TREND6`

    case $SPAP_INTYPE6 in
        0)
            INCOMING_PROTOCOL=TCP
            ;;
        1)
            INCOMING_PROTOCOL=UDP
            ;;
    esac

    case $SPAP_TRTYPE6 in
        0)
            TRIGGER_PROTOCOL=TCP
            ;;
        1)
            TRIGGER_PROTOCOL=UDP
            ;;
    esac

    if [ $SPAP_INTYPE6 != 2 ] && [ $SPAP_TRTYPE6 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
    elif [ $SPAP_INTYPE6 = 2 ] && [ $SPAP_TRTYPE6 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
    elif [ $SPAP_INTYPE6 != 2 ] && [ $SPAP_TRTYPE6 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
    elif [ $SPAP_INTYPE6 = 2 ] && [ $SPAP_TRTYPE6 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART6:$SPAP_TREND6 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART6-$SPAP_INEND6 --related-to $SPAP_INSTART6-$SPAP_INEND6
    fi
fi

if [ $SPAP_ENABLE7 -gt 0 ];
then
	eval `flash get SPAP_INTYPE7`
	eval `flash get SPAP_INSTART7`
	eval `flash get SPAP_INEND7`
	eval `flash get SPAP_TRTYPE7`
	eval `flash get SPAP_TRSTART7`
	eval `flash get SPAP_TREND7`

    case $SPAP_INTYPE7 in
        0)
            INCOMING_PROTOCOL=TCP
            ;;
        1)
            INCOMING_PROTOCOL=UDP
            ;;
    esac

    case $SPAP_TRTYPE7 in
        0)
            TRIGGER_PROTOCOL=TCP
            ;;
        1)
            TRIGGER_PROTOCOL=UDP
            ;;
    esac

    if [ $SPAP_INTYPE7 != 2 ] && [ $SPAP_TRTYPE7 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
    elif [ $SPAP_INTYPE7 = 2 ] && [ $SPAP_TRTYPE7 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
    elif [ $SPAP_INTYPE7 != 2 ] && [ $SPAP_TRTYPE7 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
    elif [ $SPAP_INTYPE7 = 2 ] && [ $SPAP_TRTYPE7 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART7:$SPAP_TREND7 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART7-$SPAP_INEND7 --related-to $SPAP_INSTART7-$SPAP_INEND7
    fi
fi

if [ $SPAP_ENABLE8 -gt 0 ];
then
	eval `flash get SPAP_INTYPE8`
	eval `flash get SPAP_INSTART8`
	eval `flash get SPAP_INEND8`
	eval `flash get SPAP_TRTYPE8`
	eval `flash get SPAP_TRSTART8`
	eval `flash get SPAP_TREND8`

    case $SPAP_INTYPE8 in
        0)
            INCOMING_PROTOCOL=TCP
            ;;
        1)
            INCOMING_PROTOCOL=UDP
            ;;
    esac

    case $SPAP_TRTYPE8 in
        0)
            TRIGGER_PROTOCOL=TCP
            ;;
        1)
            TRIGGER_PROTOCOL=UDP
            ;;
    esac

    if [ $SPAP_INTYPE8 != 2 ] && [ $SPAP_TRTYPE8 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-$SPAP_INEND8
    elif [ $SPAP_INTYPE8 = 2 ] && [ $SPAP_TRTYPE8 != 2 ]; then
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-$SPAP_INEND8
        iptables -t nat -A PREROUTING -p $TRIGGER_PROTOCOL --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-$SPAP_INEND8
    elif [ $SPAP_INTYPE8 != 2 ] && [ $SPAP_TRTYPE8 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-$SPAP_INEND8
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto $INCOMING_PROTOCOL --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-$SPAP_INEND8
    elif [ $SPAP_INTYPE8 = 2 ] && [ $SPAP_TRTYPE8 = 2 ]; then
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-$SPAP_INEND8
        iptables -t nat -A PREROUTING -p TCP --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-:$SPAP_INEND8
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto TCP --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-$SPAP_INEND8
        iptables -t nat -A PREROUTING -p UDP --dport $SPAP_TRSTART8:$SPAP_TREND8 -i $BRIDGE -j autofw --related-proto UDP --related-dport $SPAP_INSTART8-$SPAP_INEND8 --related-to $SPAP_INSTART8-$SPAP_INEND8
    fi
fi


if [ $PORTFW_TBL_NUM -gt 0 ] && [ $PORTFW_ENABLED -gt 0 ];
then
  num=1
  while [ $num -le $PORTFW_TBL_NUM ];
  do
    PORTFW_TBL=`flash get PORTFW_TBL | grep PORTFW_TBL$num`
    port_ip=`echo $PORTFW_TBL | cut -f2 -d=`
    ip=`echo $port_ip | cut -f1 -d,`
    port1=`echo $port_ip | cut -f2 -d,`
    tmp_port=`echo $port_ip | cut -f3 -d,`
    port2=`echo $tmp_port | cut -f2 -d ' '`
    protocol=`echo $port_ip | cut -f4 -d,`
    num=`expr $num + 1`

    if [ $protocol = 1 ]; then
       iptables -A PREROUTING -t nat -p TCP --dport $port1:$port2 -d $EXT_IP -j DNAT --to $ip
       iptables  -A FORWARD  -i $WAN -d $ip -p TCP --dport $port1:$port2 -j ACCEPT

    fi
    if [ $protocol = 2 ]; then
       iptables -A PREROUTING -t nat -p UDP --dport $port1:$port2 -d $EXT_IP -j DNAT --to $ip
       iptables  -A FORWARD  -i $WAN -d $ip -p UDP --dport $port1:$port2 -j ACCEPT
    fi
    if [ $protocol = 3 ]; then
       iptables -A PREROUTING -t nat -p TCP --dport $port1:$port2 -d $EXT_IP -j DNAT --to $ip
       iptables -A PREROUTING -t nat -p UDP --dport $port1:$port2 -d $EXT_IP -j DNAT --to $ip
       iptables  -A FORWARD  -i $WAN -d $ip -p TCP --dport $port1:$port2 -j ACCEPT
       iptables  -A FORWARD  -i $WAN -d $ip -p UDP --dport $port1:$port2 -j ACCEPT
    fi
  done
fi

#maxchang, remote management port, modified by Richard H., 2006/3/6
if [ $WEB_WAN_ACCESS_ENABLED = 1 ];then
	iptables -A INPUT -i $WAN -p tcp -d $LAN_IP --dport 80 -j ACCEPT
  	iptables -t nat -A PREROUTING -i $WAN -p tcp -d $EXT_IP --dport $REMOTEMGTPORT -j DNAT --to $LAN_IP:80
fi

#added for remote telent by Richard H., 2006/4/24
if [ $REMOTE_TELNET = 1 ];then
  	iptables -A INPUT -i $WAN -p tcp -d $EXT_IP --dport 23 -j ACCEPT
fi

if [ "$DMZ_HOST" != '0.0.0.0' ] && [ $DMZ_ENABLED -gt 0 ];
then
  iptables -A PREROUTING -t nat -p ALL -d $EXT_IP -j DNAT --to $DMZ_HOST
  iptables  -A FORWARD  -i $WAN -d $DMZ_HOST -p all -j ACCEPT
fi

#deny the ping request from WAN interface by Richard H., 2005/9/16
eval `flash get PING_WAN_ENABLED`
if [ $PING_WAN_ENABLED = 1 ];then
	iptables -A INPUT -p icmp --icmp-type echo-request -i $WAN -d $EXT_IP -j ACCEPT
fi

#add the default forward rule after filter
echo "4096" > /proc/sys/net/ipv4/ip_conntrack_max
echo "7200" > /proc/sys/net/ipv4/netfilter/ip_conntrack_tcp_timeout_established
iptables -A INPUT -i ! $WAN -j ACCEPT

# let ipsec packet come in
if [ -f /bin/vpn.sh ] && [ $WAN_DHCP != 4 ] && [ $OP_MODE != 1 ]; then
	eval `flash get IPSECTUNNEL_ENABLED`
	if [ $IPSECTUNNEL_ENABLED -gt 0 ]; then
		iptables -A INPUT -p 50 -i $WAN -j ACCEPT
		iptables -A INPUT -p 51 -i $WAN -j ACCEPT
		iptables -A INPUT -p udp --sport 500 --dport 500 -i $WAN -j ACCEPT
	fi
fi

iptables -A INPUT -m state --state ESTABLISHED,RELATED -j ACCEPT
iptables -A FORWARD -p tcp --tcp-flags SYN,RST SYN -j TCPMSS --clamp-mss-to-pmtu
iptables -A FORWARD -p udp -i $WAN -o $BRIDGE -j ACCEPT
iptables -A FORWARD -p tcp -i $WAN -o $BRIDGE -j ACCEPT
iptables -A FORWARD -p 50 -i $WAN -o $BRIDGE -j ACCEPT
iptables  -A FORWARD -i $BRIDGE -j ACCEPT
iptables  -A FORWARD -i $WAN -m state --state ESTABLISHED,RELATED -j ACCEPT
iptables -t mangle -I PREROUTING -i $BRIDGE -j MARK --set-mark 5

if [ $MODEL_TYPE = "ZYXELRUS" ]; then
    if [ $WAN_DHCP = 3 ] || [ $WAN_DHCP = 4 ] || [ $WAN_DHCP = 5 ]; then
        if [ "$OP_MODE" = '0' ];then
            EXT_IF=eth1
        elif [ "$OP_MODE" = '2' ];then
            EXT_IF=wlan$WISP_WAN_ID
        fi

        iptables -A FORWARD -i $EXT_IF -j ACCEPT
    fi
fi

DOS_STR=`flash all | grep DOS_ENABLED`
if [ "$DOS_STR" != "" ]; then
dos.sh &
fi
