#!/bin/sh
WAN=$1
START_DHCP_CLIENT=dhcpc.sh
OPTIONS=/etc/ppp/options
L2TPCONF=/etc/ppp/l2tpd.conf
RESOLV=/etc/ppp/resolv.conf
FIRSTFILE=/etc/ppp/firstl2tp
CONNECTFILE=/etc/ppp/connectfile
L2TPPID=/var/run/l2tpd.pid
L2TPCONTROL=/var/run/l2tp-control
HNAME=wr254
CONNECTED=/var/run/l2tp-connected

if [ -f "$CONNECTED" ]; then
        TID=`cat $CONNECTED | grep d`
        echo "$TID" > $L2TPCONTROL
	rm $CONNECTED
fi

if [ -f "$L2TPPID" ]; then
	killall -9 l2tpd
	rm $FIRSTFILE
	rm $CONNECTFILE
	rm $L2TPPID
	rm $L2TPCONTROL
fi

eval `flash get L2TP_USER_NAME`
eval `flash get L2TP_PASSWORD`
eval `flash get L2TP_IP_ADDR`
eval `flash get L2TP_SUBNET_MASK`
eval `flash get L2TP_SERVER_IP_ADDR`
eval `flash get L2TP_MTU_SIZE`
eval `flash get L2TP_TIMEOUT`
eval `flash get L2TP_IPMODE`
eval `flash get DNS_MODE`
eval `flash get DNS1`
eval `flash get DNS2`
eval `flash get DNS3`
eval `flash get WAN_DHCP`
eval `flash get WAN_DEFAULT_GATEWAY`

if [ $DNS_MODE = 1 ]; then
	if [ "$DNS1" != '0.0.0.0' ]; then
		DNS="$DNS -s $DNS1"
	fi
	if [ "$DNS2" != '0.0.0.0' ]; then
		DNS="$DNS -s $DNS2"
	fi
	if [ "$DNS3" != '0.0.0.0' ]; then
		DNS="$DNS -s $DNS3"
	fi
	dnrd $DNS
else
	dnrd -s 168.95.1.1
fi

#added by Richard H., 2006/1/17
#eval `flash get MODEL_TYPE`
#if [ $MODEL_TYPE = "ZYXELRUS" ]; then
    if [ $L2TP_IPMODE = 1 ]; then
    	ifconfig $WAN addr $L2TP_IP_ADDR netmask $L2TP_SUBNET_MASK

      #echo "delete default route at WAN port..."
    	#del_route=`route -n | grep eth1`

    	#del_net_1=`echo $del_route | cut -f1 -d.`
    	#del_net_2=`echo $del_route | cut -f2 -d.`
    	#del_net_3=`echo $del_route | cut -f3 -d.`

    	#del_netmask=`echo $del_route | cut -f7 -d.`
    	#del_netmask_1=`echo $del_netmask | cut -b 3-`
    	#del_netmask_2=`echo $del_route | cut -f8 -d.`
    	#del_netmask_3=`echo $del_route | cut -f9 -d.`
    	
    	echo "Add route to L2TP server..."

    	route add $L2TP_SERVER_IP_ADDR gw $WAN_DEFAULT_GATEWAY dev eth1
    
    	#route del -net $del_net_1.$del_net_2.$del_net_3.0 netmask $del_netmask_1.$del_netmask_2.$del_netmask_3.0 eth1
    else
      $START_DHCP_CLIENT $WAN wait&
    fi
#else
#    if [ $L2TP_IPMODE = 1 ]; then
#    	ifconfig $WAN addr $L2TP_IP_ADDR netmask $L2TP_SUBNET_MASK
#    	sleep 3
#    else
#      $START_DHCP_CLIENT $WAN wait&
#      sleep 3
#    fi
#fi

route del default dev $WAN

######################/etc/ppp/options
if [ -n "$L2TP_USER_NAME" ] ; then
	echo "name $L2TP_USER_NAME" > $OPTIONS
	echo "password $L2TP_PASSWORD" >> $OPTIONS
	#echo "#################################################" > $PAPFILE
	#echo "\"$L2TP_USER_NAME\"	*	\"$L2TP_PASSWORD\"" >> $PAPFILE
	#echo "#################################################" > $CHAPFILE
	#echo "\"$L2TP_USER_NAME\"	*	\"$L2TP_PASSWORD\"" >> $CHAPFILE
fi

echo "nomppe" >> $OPTIONS
echo "noccp" >> $OPTIONS

echo "hide-password" >> $OPTIONS
echo "lock" >> $OPTIONS
echo "noauth" >> $OPTIONS
echo "nobsdcomp" >> $OPTIONS
echo "nodeflate" >> $OPTIONS
echo "usepeerdns" >> $OPTIONS
echo "lcp-echo-interval 20" >> $OPTIONS
echo "lcp-echo-failure 3" >> $OPTIONS
echo "mtu $L2TP_MTU_SIZE" >> $OPTIONS
if [ $L2TP_TIMEOUT -gt 0 ]; then
	echo "idle $L2TP_TIMEOUT" >> $OPTIONS
fi
echo "defaultroute" >> $OPTIONS
echo "disconnect /bin/l2tp-disconnect.sh" >> $OPTIONS


######################/etc/l2tpd/l2tpd.conf
echo "[global]" > $L2TPCONF
#echo "listen-addr" >> $L2TPCONF
echo "port = 1701" >> $L2TPCONF
echo "[lac $HNAME]" >> $L2TPCONF
echo "lns = $L2TP_SERVER_IP_ADDR" >> $L2TPCONF
echo "autodial = yes" >> $L2TPCONF
echo "redial = yes" >> $L2TPCONF
echo "redial timeout = 10" >> $L2TPCONF
echo "max redials = 5" >> $L2TPCONF
echo "call rws = 10" >> $L2TPCONF
echo "tunnel rws = 4" >> $L2TPCONF
echo "flow bit = yes" >> $L2TPCONF

PID_FILE=/var/run/ppp0.pid
DNRD_PID=/var/run/dnrd.pid
if [ $WAN_DHCP = 5 ]; then
	if [ ! -f $FIRSTFILE ]; then
	{
		echo "pass" > $FIRSTFILE
		while [ true ]; do
			eval `flash get WAN_DHCP`
			if [ $WAN_DHCP != 5 ]; then
				break
			fi
			if [ ! -r "$CONNECTFILE" ]; then
				echo "pass" > $CONNECTFILE
				upnp.sh
				sleep 5
				l2tpd -c $L2TPCONF
			fi
			sleep 3
		done
		rm -f $FIRSTFILE
	} &
	fi
fi
