#!/bin/sh
#WAN=eth1
WAN=$2
OPTIONS=/etc/ppp/options
PAPFILE=/etc/ppp/pap-secrets
CHAPFILE=/etc/ppp/chap-secrets
RESOLV=/etc/ppp/resolv.conf
LINKFILE=/etc/ppp/link
PPPFILE=/var/run/ppp
FIRSTFILE=/etc/ppp/first
FIRSTDEMAND=/etc/ppp/firstdemand
CONNECTFILE=/etc/ppp/connectfile
eval `flash get PPP_USER_NAME`
eval `flash get EXTRA_PPP_USER_NAME`
eval `flash get PPP_PASSWORD`
eval `flash get PPP_IDLE_TIME`
eval `flash get PPP_CONNECT_TYPE`
eval `flash get PPP_MTU_SIZE`
eval `flash get DNS_MODE`
eval `flash get DNS1`
eval `flash get DNS2`
eval `flash get DNS3`

# added by Eason, 2006/2/23
eval `flash get MODEL_TYPE`
if [ $MODEL_TYPE = "ZYXELRUS" ]; then
	eval `flash get MPPE_LEVEL`
	eval `flash get PPP_IPMODE`
	eval `flash get PPP_IPMODE_DIALUP`
	eval `flash get PPP_AUTH_TYPE`
	if [ $PPP_IPMODE_DIALUP = 1 ]; then
		eval `flash get PPP_IP_ADDR`
		eval `flash get PPP_REMOTE_IP_ADDR`
		eval `flash get PPP_REMOTE_SUBNET_MASK`
	fi

    # added by MaxChang, 2006/4/12 --------------------
	eval `flash get OP_MODE`
	if [ "$OP_MODE" = '0' ];then
        EXT_IF=eth1
    elif [ "$OP_MODE" = '2' ];then
        EXT_IF=wlan$WISP_WAN_ID
    fi

    eval `flash get PHY_WAN_IP_ADDR`
    eval `flash get PHY_WAN_SUBNET_MASK`

    PHYWAN_IP=$PHY_WAN_IP_ADDR
    PHYWAN_MASK=$PHY_WAN_SUBNET_MASK

    #ifconfig eth1 0.0.0.0
    if [ $PPP_IPMODE = 0 ]; then
    	dhcpc.sh $EXT_IF wait&
    else
    	ifconfig $EXT_IF $PHYWAN_IP netmask $PHYWAN_MASK
    	echo "" > $RESOLV
    fi
    #---------------------------------------------------
fi

#MSS=`expr $PPP_MTU_SIZE - 40`
route del default gw 0.0.0.0 dev $WAN
if [ $1 = 'connect' ]; then
     ENABLE_CONNECT=1
else
     ENABLE_CONNECT=0
fi
if [ -n "$PPP_USER_NAME" ] ; then
  echo "name \"$PPP_USER_NAME$EXTRA_PPP_USER_NAME\"" > $OPTIONS
  echo "#################################################" > $PAPFILE
  echo "\"$PPP_USER_NAME$EXTRA_PPP_USER_NAME\"	*	\"$PPP_PASSWORD\"" >> $PAPFILE
  echo "#################################################" > $CHAPFILE
  echo "\"$PPP_USER_NAME$EXTRA_PPP_USER_NAME\"	*	\"$PPP_PASSWORD\"" >> $CHAPFILE
fi

#echo "sync" >> $OPTIONS
echo "noauth" >> $OPTIONS
echo "noipdefault" >> $OPTIONS
echo "hide-password" >> $OPTIONS
echo "defaultroute" >> $OPTIONS
echo "persist" >> $OPTIONS
echo "ipcp-accept-remote" >> $OPTIONS
echo "ipcp-accept-local" >> $OPTIONS
if [ $MODEL_TYPE = "ZYXELRUS" ]; then
	if [ $PPP_IPMODE_DIALUP = 1 ]; then
		echo "$PPP_IP_ADDR:$PPP_REMOTE_IP_ADDR" >> $OPTIONS
		echo "netmask $PPP_REMOTE_SUBNET_MASK" >> $OPTIONS
	fi

	case $PPP_AUTH_TYPE in
		0)
			echo "refuse-chap" >> $OPTIONS
			echo "refuse-mschap" >> $OPTIONS
			echo "refuse-mschap-v2" >> $OPTIONS
			;;
		1)
			echo "refuse-pap" >> $OPTIONS
			echo "refuse-mschap" >> $OPTIONS
			echo "refuse-mschap-v2" >> $OPTIONS
			;;
		2)
			echo "refuse-pap" >> $OPTIONS
			echo "refuse-chap" >> $OPTIONS
			echo "refuse-mschap-v2" >> $OPTIONS
			;;
		3)
			echo "refuse-pap" >> $OPTIONS
			echo "refuse-chap" >> $OPTIONS
			echo "refuse-mschap" >> $OPTIONS
			;;
	esac

	if [ $PPP_AUTH_TYPE -le 1 ]; then
		echo "noccp" >> $OPTIONS
		echo "nomppe" >> $OPTIONS
	else
		case $MPPE_LEVEL in
		0)
			echo "noccp" >> $OPTIONS
			echo "nomppe" >> $OPTIONS
			;;
		1)
			echo "+mppe required,stateless,no56,no128" >> $OPTIONS
			;;
		2)
			echo "+mppe required,stateless,no40,no128" >> $OPTIONS
			;;
		3)
			echo "+mppe required,stateless,no40,no56" >> $OPTIONS
			;;
	esac
	fi
fi
echo "nodetach" >> $OPTIONS
echo "usepeerdns" >> $OPTIONS
echo "mtu $PPP_MTU_SIZE" >> $OPTIONS
echo "mru $PPP_MTU_SIZE" >> $OPTIONS
echo "lcp-echo-interval 20" >> $OPTIONS
echo "lcp-echo-failure 3" >> $OPTIONS
echo "plugin /etc/ppp/plugins/libplugin.a $WAN" >> $OPTIONS
#echo "plugin /etc/ppp/plugins/libplugin.a rp_pppoe_service   \"62031090091412-Seednet_39_161\"  $WAN"  >> $OPTIONS

PID_FILE=/var/run/ppp0.pid
DNRD_PID=/var/run/dnrd.pid

#/bin/disconnect.sh all

if [ ! -f $DNRD_PID ]; then
   if [ $DNS_MODE != 1 ]; then
      dnrd -s 168.95.1.1
   fi
   if [ $DNS_MODE = 1 ]; then
      if [ "$DNS1" != '0.0.0.0' ]; then
        DNS="$DNS -s $DNS1"
      fi
      if [ "$DNS2" != '0.0.0.0' ]; then
        DNS="$DNS -s $DNS2"
      fi
      if [ "$DNS3" != '0.0.0.0' ]; then
        DNS="$DNS -s $DNS3"
      fi
      dnrd $DNS
   fi
fi



if [ -r "$PPPFILE" ]; then
  rm $PPPFILE
fi

if [ $PPP_CONNECT_TYPE = 0 ] ; then
  if [ ! -f $FIRSTFILE ]; then
  {
  echo "pass" > $FIRSTFILE
  while [ true ]; do
  eval `flash get PPP_CONNECT_TYPE`
  eval `flash get WAN_DHCP`

  if [ $WAN_DHCP != 3 ] || [ $PPP_CONNECT_TYPE != 0 ]; then
    break
  fi
  if [ ! -r "$CONNECTFILE" ]  && [ $PPP_CONNECT_TYPE = 0 ]; then
    echo "pass" > $CONNECTFILE
    upnp.sh
    sleep 5
    #pppd pty "pppoe -I $WAN -m $MSS -s"
    pppd
  fi
  sleep 3
  done
  rm -f $FIRSTFILE
  } &
  fi
fi

if [ $PPP_CONNECT_TYPE = 1 ] ; then
  echo "demand" >> $OPTIONS
  echo "idle $PPP_IDLE_TIME" >> $OPTIONS
  if [ ! -f $FIRSTDEMAND ]; then
  {
  echo "pass" > $FIRSTDEMAND
  while [ true ]; do
  eval `flash get PPP_CONNECT_TYPE`
  eval `flash get WAN_DHCP`

  if [ $WAN_DHCP != 3 ] || [ $PPP_CONNECT_TYPE != 1 ]; then
    break
  fi
  if [ ! -r "$CONNECTFILE" ]  && [ $PPP_CONNECT_TYPE = 1 ]; then
    echo "pass" > $CONNECTFILE
    upnp.sh
    sleep 5
    #pppd pty "pppoe -I $WAN -T 80 -U -m $MSS -s"
    pppd
  fi
  sleep 3
  done
  rm -f $FIRSTDEMAND
  } &
  fi
fi


if [ $PPP_CONNECT_TYPE = 2 ]; then
 upnp.sh
   if [ $ENABLE_CONNECT = 1 ]; then
   sleep 5
   #pppd pty "pppoe -I $WAN -m $MSS -s" &
   pppd &
   fi
fi