#!/bin/sh
#WAN=eth1
WAN=$1
OPTIONS=/etc/ppp/options
RPPTP=/etc/ppp/peers/rpptp
PAPFILE=/etc/ppp/pap-secrets
CHAPFILE=/etc/ppp/chap-secrets
RESOLV=/etc/ppp/resolv.conf
PPPFILE=/var/run/ppp
FIRSTFILE=/etc/ppp/firstpptp
CONNECTFILE=/etc/ppp/connectfile

eval `flash get PPTP_USER_NAME`
eval `flash get PPTP_PASSWORD`
eval `flash get PPTP_IP_ADDR`
eval `flash get PPTP_SUBNET_MASK`
eval `flash get PPTP_SERVER_IP_ADDR`
eval `flash get PPTP_MTU_SIZE`
eval `flash get DNS_MODE`
eval `flash get DNS1`
eval `flash get DNS2`
eval `flash get DNS3`
eval `flash get WAN_DHCP`
eval `flash get PPTP_AUTH_TYPE`
eval `flash get MPPE_LEVEL`
eval `flash get WAN_DEFAULT_GATEWAY`

#added by Richard H., 2006/1/17
eval `flash get MODEL_TYPE`
if [ $MODEL_TYPE = "ZYXELRUS" ]; then
	eval `flash get PPTP_SERVER_INFO`
	eval `flash get PPTP_SERVER_URL_ADDR`
	eval `flash get PPTP_IPMODE`
fi

#disconnect.sh all

if [ $DNS_MODE = 1 ]; then
      if [ "$DNS1" != '0.0.0.0' ]; then
        DNS="$DNS -s $DNS1"
      fi
      if [ "$DNS2" != '0.0.0.0' ]; then
        DNS="$DNS -s $DNS2"
      fi
      if [ "$DNS3" != '0.0.0.0' ]; then
        DNS="$DNS -s $DNS3"
      fi
    dnrd $DNS
 else
    dnrd -s 168.95.1.1
fi

#added by Richard H., 2006/1/17
if [ $MODEL_TYPE = "ZYXELRUS" ]; then
    if [ $PPTP_IPMODE = 0 ]; then
    	dhcpc.sh $WAN wait&
    else
      ifconfig $WAN addr $PPTP_IP_ADDR  netmask $PPTP_SUBNET_MASK
    	echo "Add route to PPTP server..."

	   	route add $PPTP_SERVER_IP_ADDR gw $WAN_DEFAULT_GATEWAY dev eth1
    fi
else
	ifconfig $WAN addr $PPTP_IP_ADDR  netmask $PPTP_SUBNET_MASK
	echo "Add route to PPTP server..."
	
	route add $PPTP_SERVER_IP_ADDR gw $WAN_DEFAULT_GATEWAY dev eth1
fi

route del default dev $WAN
if [ -n "$PPTP_USER_NAME" ] ; then
  echo "name \"$PPTP_USER_NAME\"" > $OPTIONS
  echo "#################################################" > $PAPFILE
  echo "\"$PPTP_USER_NAME\"	*	\"$PPTP_PASSWORD\"" >> $PAPFILE
  echo "#################################################" > $CHAPFILE
  echo "\"$PPTP_USER_NAME\"	*	\"$PPTP_PASSWORD\"" >> $CHAPFILE
fi

echo "nodetach" >> $OPTIONS
echo "lock" >> $OPTIONS
echo "nobsdcomp" >> $OPTIONS
echo "nodeflate" >> $OPTIONS
echo "usepeerdns" >> $OPTIONS
echo "lcp-echo-interval 20" >> $OPTIONS
echo "lcp-echo-failure 3" >> $OPTIONS
echo "mtu $PPTP_MTU_SIZE" >> $OPTIONS
if [ $PPTP_AUTH_TYPE -le 1 ]; then
	echo "noccp" >> $OPTIONS
	echo "nomppe" >> $OPTIONS
else
	case $MPPE_LEVEL in
		0)
			echo "noccp" >> $OPTIONS
			echo "nomppe" >> $OPTIONS
			;;
		1)
			echo "+mppe required,stateless,no56,no128" >> $OPTIONS
			;;
		2)
			echo "+mppe required,stateless,no40,no128" >> $OPTIONS
			;;
		3)
			echo "+mppe required,stateless,no40,no56" >> $OPTIONS
			;;
	esac
fi

echo "remotename PPTP" > $RPPTP
echo "linkname PPTP" >> $RPPTP
echo "ipparam PPTP" >> $RPPTP
echo "name $PPTP_USER_NAME" >> $RPPTP

#modified by Richard H., 2006/1/17
if [ $MODEL_TYPE = "ZYXELRUS" ]; then
	if [ $PPTP_SERVER_INFO = 1 ]; then
		echo "pty \"pptp $PPTP_SERVER_URL_ADDR --nolaunchpppd\"" >> $RPPTP
	else
		echo "pty \"pptp $PPTP_SERVER_IP_ADDR --nolaunchpppd\"" >> $RPPTP
	fi
else
	echo "pty \"pptp $PPTP_SERVER_IP_ADDR --nolaunchpppd\"" >> $RPPTP
fi

case $PPTP_AUTH_TYPE in
	0)
		echo "refuse-chap" >> $RPPTP
		echo "refuse-mschap" >> $RPPTP
		echo "refuse-mschap-v2" >> $RPPTP
		echo "require-pap" >> $RPPTP
		;;
	1)
		echo "refuse-pap" >> $RPPTP
		echo "refuse-mschap" >> $RPPTP
		echo "refuse-mschap-v2" >> $RPPTP
		echo "require-chap" >> $RPPTP
		;;
	2)
		echo "refuse-pap" >> $RPPTP
		echo "refuse-chap" >> $RPPTP
		echo "refuse-mschap-v2" >> $RPPTP
		echo "require-mschap" >> $RPPTP
		;;
	3)
		echo "refuse-pap" >> $RPPTP
		echo "refuse-chap" >> $RPPTP
		echo "refuse-mschap" >> $RPPTP
		echo "require-mschap-v2" >> $RPPTP
		;;
esac
echo "noauth" >> $RPPTP
echo "file /etc/ppp/options" >>$RPPTP

PID_FILE=/var/run/ppp0.pid
DNRD_PID=/var/run/dnrd.pid
if [ $WAN_DHCP = 4 ]; then
  if [ ! -f $FIRSTFILE ]; then
  {
  echo "pass" > $FIRSTFILE
  while [ true ]; do
  eval `flash get WAN_DHCP`
  if [ $WAN_DHCP != 4 ]; then
    break
  fi

  if [ ! -r "$CONNECTFILE" ]; then
    echo "pass" > $CONNECTFILE
    upnp.sh
    sleep 5
    pppd call rpptp
  fi
  sleep 3
  done
  rm -f $FIRSTFILE
  } &
  fi
fi

